//
//  EtasClient.m
//  esand_ios_demo
//
//  Created by ReidLee on 2018/6/15.
//  Copyright © 2018年 esandinfo. All rights reserved.
//

#import "EtasClient.h"

// 此类为了实现跟业务服务器进行数据同步
@implementation EtasClient
{
    NSURL * _nsURL;
}

- (id) initWithNSURL:(NSURL *)nsURL
{
    self = [super init];
    if (self) {
        
        _nsURL = nsURL;
    }
    
    return self;
}

// 为了方便把流程说清楚，这里用了同步方法，在接入的时候兼用用异步方式实现。
- (NSString *) requestSync:(NSString *)bodyString{
    HKLog(@"bodyString = %@", bodyString);
    
    NSString* resultStr = nil;
    NSMutableURLRequest *nsMutableURLRequest = [NSMutableURLRequest requestWithURL:_nsURL
                                                                       cachePolicy:NSURLRequestReloadIgnoringLocalCacheData
                                                                   timeoutInterval:10];
    //POST请求
    [nsMutableURLRequest setHTTPMethod:@"POST"];
    //把bodyString转换为NSData数据
    NSData *bodyData =  [bodyString dataUsingEncoding:NSUTF8StringEncoding];
    //请求头
    [nsMutableURLRequest setValue:@"application/json" forHTTPHeaderField:@"content-type"];
    [nsMutableURLRequest setValue:@"UTF-8" forHTTPHeaderField:@"Charset"];
    //body 数据
    [nsMutableURLRequest setHTTPBody:bodyData];
    
    NSURLResponse * response = nil;
    NSError * connectionError = nil;
    NSData * data = [NSURLConnection sendSynchronousRequest:nsMutableURLRequest
                                          returningResponse:&response
                                                      error:&connectionError];
    if (!connectionError) {
        
        HKLog(@"%@", [[NSString alloc]initWithData:data encoding:NSUTF8StringEncoding]);
        HKLog(@"%@", connectionError);
    }
    resultStr = [[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding];
    return resultStr;
}
@end
